-- Test program for the PIC library
-- /Mic, 2002

include pic.e
include machine.e

sequence img,header
integer fn,size,width,height,bpp
atom t1,t2


fn = open("encoded.dat","rb")
if fn=-1 then
	puts(1,"Run encode.ex first")
	abort(0)
end if

header = {}
for i=1 to 54 do
	header &= getc(fn)
end for
width = bytes_to_int(header[19..22])
height = bytes_to_int(header[23..26])
bpp = bytes_to_int(header[29..30]&{0,0})

-- Copy the palette if there is one
if bpp=8 then
	for i=1 to 1024 do
		header &= getc(fn)
	end for
end if

-- Allocate memory for the image
img = {allocate(width*height*floor(bpp/8)),width,height,bpp}

puts(1,"Decoding..")
t1 = time()
size = pic_decode(fn,img)
t2 = time()

close(fn)

if size=0 then
	puts(1,"\nDecompression failed!\n")
	abort(0)
end if

-- Create the .bmp file
fn = open("decoded.bmp","wb")
puts(fn,header)

for y=height-1 to 0 by -1 do	-- DIB:s are stored top-down..
	for x=0 to width-1 do
		for bits=0 to floor(bpp/8)-1 do
			puts(fn,peek(img[1] + (((y * width) + x) * floor(bpp/8)) + bits))
		end for
	end for
end for

close(fn)
free(img[1])


printf(1,"Done!\nDecoding time: %1.2f s\n",t2-t1)
if t2>t1 then
	printf(1,"Throughput: %d KB/s\n",floor((img[2]*img[3]*floor(img[4]/8))/((t2-t1)*1024)))
end if
printf(1,"Bytes: %d\n",size)

puts(1,"\nPress any key..")
while get_key()=-1 do end while

