-- Test program for the PIC library
-- /Mic, 2002

constant SOURCE = "maruko.bmp"

include bmp.e
include pic.e

sequence img,header
integer fn,size
atom t1,t2


-- Copy the bitmap header
header = {}
fn = open(SOURCE,"rb")
for i=1 to 54 do
	header &= getc(fn)
end for
close(fn)

-- Load the bitmap
img = load_bmp(SOURCE)
if img[1]=-1 then
	puts(1,"Unable to load "&SOURCE)
	abort(0)
end if

fn = open("encoded.dat","wb")
puts(fn,header)
-- Copy the palette as well if it's an 8-bit image
if img[4]=8 then
	for i=1 to 256 do
		puts(fn,{img[5][i][3],img[5][i][2],img[5][i][1],0})
	end for
end if

puts(1,"Encoding..")
t1 = time()
size = pic_encode(img,fn)
t2 = time()

free(img[1])
close(fn)

if size=0 then
	puts(1,"\nEncoding failed!\n")
	abort(0)
end if


printf(1,"Done!\nEncoding time: %1.2f s\n",t2-t1)
printf(1,"Compression ratio: %1.2f:1\n",(img[2]*img[3]*floor(img[4]/8)) / size)
if t2>t1 then
	printf(1,"Throughput: %d KB/s\n",floor((img[2]*img[3]*floor(img[4]/8))/((t2-t1)*1024)))
end if

puts(1,"\nPress any key..")
while get_key()=-1 do end while

